<link rel="import" href="../../bower_components/polymer/polymer-element.html">

<dom-module id="dez-number-row">
  <template>
    <div/>
  </template>
  <script>
    // Event handlers for digit keys, on azerty and qwerty keyboards

    class DezNumberRow extends Polymer.Element {

      constructor() {
        super();

        // A map storing currently active keys as 'true' and previously active keys as 'false'
        // Indexed by _getRowPosition
        this._activeKeys = {}
      }

      static get is() { return 'dez-number-row'; }

      connectedCallback() {
        super.connectedCallback();

        // Listens to all uncaptured keyboard events to send custom events 
        document.addEventListener('keyup', (e) => this._handleNumberRow(e), false);
        document.addEventListener('keydown', (e) => this._handleNumberRow(e), false);
      }

      disconnectedCallback() {
        super.disconnectedCallback();

        // Remove listeners
        document.removeEventListener('keyup', (e) => this._handleNumberRow(e), false);
        document.removeEventListener('keydown', (e) => this._handleNumberRow(e), false);

        // Set all keys as unattached to force all pending animation frames to return
        for (const key of Object.keys(this._activeKeys))
          this._activeKeys[key] = false;
      }

      _getRowPosition(event) {
        switch (event.code) {
          case 'Digit1': return 0;
          case 'Digit2': return 1;
          case 'Digit3': return 2;
          case 'Digit4': return 3;
          case 'Digit5': return 4;
          case 'Digit6': return 5;
          case 'Digit7': return 6;
          case 'Digit8': return 7;
          case 'Digit9': return 8;
          case 'Digit0': return 9;
          default: return;
        }
      }

      // Send animation updates events similar to native key repeat events
      _sendKeyRepeatEvent(position) {

        if (!this._activeKeys[position])
          return;

        this.dispatchEvent(new CustomEvent(
          'number-row-repeat',
          { detail: { position } }
        ));

        window.requestAnimationFrame(() => this._sendKeyRepeatEvent(position));
      }

      // Transform keyboard events into specialized keyboard digit row events
      _handleNumberRow(event) {
        let numberRowPos = this._getRowPosition(event);


        // If not a number row event, or a repeat event, ignore
        if (event.repeat || numberRowPos === undefined) return;
        // If not an up or down event, ignore
        if (event.type !== 'keyup' && event.type !== 'keydown') return;

        // Set key as 'down'
        this._activeKeys[numberRowPos] = event.type === 'keydown';

        // Dispatch number-row-keydown or number-row-keyup
        // Position 0 matches the key '1', 1 matches the key '2', etc.
        this.dispatchEvent(new CustomEvent(
          'number-row-' + event.type,
          { detail: { keyboardEvent: event, position: numberRowPos } }
        ));

        // Start dispatching repeat events
        this._sendKeyRepeatEvent(numberRowPos);
      }
    }

    window.customElements.define(DezNumberRow.is, DezNumberRow);

  </script>
</dom-module>